#version 330 core

// Uniforms
layout (std140) uniform Matrices
{
	mat4 m_pvm;
	mat4 m_view;
	mat4 m_viewModel;
	mat4 m_projection;
	mat4 m_normal;
};

// Input layout
layout (points) in;
layout (triangle_strip, max_vertices = 4) out;

// Output data
out FragmentData
{
	vec4 position;	// Clip space
	vec2 texcoord;

} DataOut;

// Corners
const vec2 corners[4] = vec2[4]( vec2(0, 1), vec2(0, 0), vec2(1, 1), vec2(1, 0) );

void main()
{
    for (int i = 0; i < 4; i++)
    {
		vec2 c = vec2(2.5, 4) * (corners[i] - vec2(0.5));

        DataOut.position = m_projection * (gl_in[0].gl_Position + vec4(c, 0, 0));            
        DataOut.texcoord = corners[i];
		
		gl_Position = DataOut.position;
        EmitVertex();
    }
}