#version 330 core

// Uniforms
layout (std140) uniform Matrices
{
	mat4 m_pvm;
	mat4 m_view;
	mat4 m_viewModel;
	mat4 m_projection;
	mat4 m_normal;
};

layout (std140) uniform Particle
{
	vec4 p_startColor;
	vec4 p_endColor;
	uvec2 p_texImages;
	float p_texAnimSpeed;
	float p_life;
};

// Input
layout (location = 0) in vec4 v_position;
layout (location = 1) in vec2 v_scale;
layout (location = 2) in float v_rotation;
layout (location = 3) in float v_age;

// Output data
out VertexData
{
	vec4 color;
	vec2 scale;
	float rotation;
	uint subImage;

} DataOut;

// Main
void main()
{
	DataOut.color = mix(p_startColor, p_endColor, v_age / p_life);
	DataOut.scale = v_scale;
	DataOut.rotation = v_rotation;
	DataOut.subImage = uint(mod(v_age * p_texAnimSpeed, p_texImages.x * p_texImages.y));
	gl_Position = m_viewModel * v_position;
}