#version 330 core

layout (std140) uniform Matrices
{
	mat4 m_pvm;
	mat4 m_view;
	mat4 m_viewModel;
	mat4 m_projection;
	mat4 m_normal;
};

/*struct Light
{
	vec3 position;
	vec3 color;
	float power;
	vec2 nearFar;
	float Padding0;
	float Padding1;
};

layout (std140) uniform Lights
{
	int numberOfLights;
	Light light[3];
};*/

// Input
layout (location = 0) in vec4 v_position;

// Output
out Data
{
	vec4 position;	// Clip space
	vec2 texcoord;
	vec3 eye;		// Tangent space
	vec3 light[3];	// Tangent space

} DataOut;

// Main
void main()
{	
	// Texture coordiantes
	DataOut.texcoord = v_position.xz / 15;

	// Projected position
	DataOut.position = m_pvm * v_position;

	// Eye vector in view space
	DataOut.eye = -(m_viewModel * v_position).xyz;

	// Transform eye and light to tangent space
	vec3 n = normalize((m_normal * vec4(0, 1, 0, 0)).xyz);
	vec3 t = normalize((m_viewModel * vec4(1, 0, 0, 0)).xyz);
	vec3 b = cross(n, t);
	mat3 m_tbn = transpose(mat3(t, b, n));

	DataOut.eye = m_tbn * DataOut.eye;

	/*for (int i = 0; i < numberOfLights; i++)
	{
		DataOut.light[i] = m_tbn * (m_view * vec4(light[i].position, 1)).xyz;
		DataOut.light[i] = normalize(DataOut.light[i] + DataOut.eye);
	}*/

	DataOut.light[0] = normalize(m_tbn * (m_view * vec4(-1, 1, 0, 0)).xyz);

	gl_Position = DataOut.position;
}